#include "grader.h"
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>

static int h[36][1000], hcnt;
static int nv, ne, c;
static int v1[1234567], v2[1234567];

#define FOR(i,n) for (i = 0; i < (n); i++)

static int bits[16000000], nb;
static int curbit = 0;

void encode_bit(int bit) {
  if (nb >= 16000000) {
    printf("Too many bits were encoded\n");
    exit(0);
  }
  bits[nb++] = bit;
}

int decode_bit() {
 if (curbit >= nb) {
    printf("Trying to read unexisting bit\n");
    exit(0);
 }
 return bits[curbit++];
}

void hops(int a, int b, int d) {
   if (!(0 <= a && a < c) || !(0 <= b && b < nv)) {
      printf("hops() was called with invalid (a, b) = (%d, %d) [c = %d, nv = %d]\n", a, b, c, nv);
	  exit(0);   	  
   }
   if (d < 0) {
      printf("hops() was called with negative distance\n");
      exit(0);
   }
   if (h[a][b] != -1) {
      printf("hops() was called for (%d,%d) twice\n", a, b);
      exit(0);
   }
   h[a][b] = d;
   hcnt++;
}


static int checkSecret(){
    char secretBuf[200];
    scanf("%s",secretBuf);
    if (!strcmp(secretBuf,SECRET1))
        return 0;
    if (!strcmp(secretBuf,SECRET2))
        return 1;
    if (!strcmp(secretBuf,SECRET3)){
        scanf(" ");
        gets(secretBuf);
        printf(SECRET3"\n");
        puts(secretBuf);
        exit(0);
    }
    printf(SECRET3"\n");
    printf("Secret mismatch : %s\n",secretBuf);
    exit(0);
}


int _main(decodeFunction decode, encodeFunction encode) {
 int i, j;
 scanf("%d%d%d", &nv, &ne, &c);
 memset(h, -1, sizeof(h));
 FOR(i,ne) scanf("%d%d", v1+i, v2+i);
 encode(nv, c, ne, v1, v2);
 decode(nv, c);
 if (hcnt != c*nv) {
    printf("hops() was called %d times instead of %d\n", hcnt, c * nv);
    exit(0);
 }
 puts("OK");
 printf("%d\n", nb);
 for (i = 0; i < c; i++)
 	for (j = 0; j < nv; j++)
 		printf("%d%c", h[i][j], " \n"[j==nv-1]);
 return 0;
}
